// Generated by CoffeeScript 1.6.3
(function() {
  var BaseModel, ProjectMergeRequests, _ref,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  BaseModel = require('../BaseModel');

  ProjectMergeRequests = (function(_super) {
    __extends(ProjectMergeRequests, _super);

    function ProjectMergeRequests() {
      this.comment = __bind(this.comment, this);
      this.update = __bind(this.update, this);
      this.add = __bind(this.add, this);
      this.show = __bind(this.show, this);
      this.list = __bind(this.list, this);
      _ref = ProjectMergeRequests.__super__.constructor.apply(this, arguments);
      return _ref;
    }

    ProjectMergeRequests.prototype.list = function(projectId, page, perPage, fn) {
      var _this = this;
      if (page == null) {
        page = 1;
      }
      if (perPage == null) {
        perPage = 20;
      }
      if (fn == null) {
        fn = null;
      }
      if (typeof page === 'function') {
        fn = page;
        page = 1;
      } else if (typeof perPage === 'function') {
        fn = perPage;
        perPage = 20;
      }
      this.debug("Projects::mergerequests()");
      return this.get("projects/" + (parseInt(projectId)) + "/merge_requests?page=" + page + "&per_page=" + perPage, function(data) {
        if (fn) {
          return fn(data);
        }
      });
    };

    ProjectMergeRequests.prototype.show = function(projectId, mergerequestId, fn) {
      var _this = this;
      if (fn == null) {
        fn = null;
      }
      this.debug("Projects::mergerequest()");
      return this.get("projects/" + (parseInt(projectId)) + "/merge_request/@{parseInt mergerequestId}", function(data) {
        if (fn) {
          return fn(data);
        }
      });
    };

    ProjectMergeRequests.prototype.add = function(projectId, sourceBranch, targetBranch, assigneeId, title, fn) {
      var params,
        _this = this;
      if (fn == null) {
        fn = null;
      }
      this.debug("Projects::addMergeRequest()");
      params = {
        id: parseInt(projectId),
        source_branch: sourceBranch,
        target_branch: targetBranch,
        assignee_id: parseInt(assigneeId),
        title: title
      };
      return this.post("projects/" + (parseInt(projectId)) + "/merge_requests", params, function(data) {
        if (fn) {
          return fn(data);
        }
      });
    };

    ProjectMergeRequests.prototype.update = function(projectId, mergerequestId, url, fn) {
      var params,
        _this = this;
      if (fn == null) {
        fn = null;
      }
      this.debug("Projects::saveMergeRequest()");
      params = {
        access_level: parseInt(accessLevel)
      };
      return this.put("projects/" + (parseInt(projectId)) + "/merge_request/" + (parseInt(mergerequestId)), params, function(data) {
        if (fn) {
          return fn(data);
        }
      });
    };

    ProjectMergeRequests.prototype.comment = function(projectId, mergerequestId, note, fn) {
      var params,
        _this = this;
      if (fn == null) {
        fn = null;
      }
      this.debug("Projects::commentMergeRequest()");
      params = {
        id: parseInt(projectId),
        merge_request_id: parseInt(mergerequestId),
        node: note
      };
      return this.post("projects/" + (parseInt(projectId)) + "/merge_request/" + (parseInt(mergerequestId)) + "/comments", params, function(data) {
        if (fn) {
          return fn(data);
        }
      });
    };

    return ProjectMergeRequests;

  })(BaseModel);

  module.exports = function(client) {
    return new ProjectMergeRequests(client);
  };

}).call(this);
