// Generated by CoffeeScript 1.6.3
(function() {
  var BaseModel, ProjectRepository, _ref,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  BaseModel = require('../BaseModel');

  ProjectRepository = (function(_super) {
    __extends(ProjectRepository, _super);

    function ProjectRepository() {
      this.updateFile = __bind(this.updateFile, this);
      this.createFile = __bind(this.createFile, this);
      this.listTree = __bind(this.listTree, this);
      this.diffCommit = __bind(this.diffCommit, this);
      this.showCommit = __bind(this.showCommit, this);
      this.listCommits = __bind(this.listCommits, this);
      this.listTags = __bind(this.listTags, this);
      this.showBranch = __bind(this.showBranch, this);
      this.listBranches = __bind(this.listBranches, this);
      _ref = ProjectRepository.__super__.constructor.apply(this, arguments);
      return _ref;
    }

    ProjectRepository.prototype.listBranches = function(projectId, fn) {
      var _this = this;
      if (fn == null) {
        fn = null;
      }
      this.debug("Projects::listBranches()");
      return this.get("projects/" + (parseInt(projectId)) + "/repository/branches", function(data) {
        if (fn) {
          return fn(data);
        }
      });
    };

    ProjectRepository.prototype.showBranch = function(projectId, branchId, fn) {
      var _this = this;
      if (fn == null) {
        fn = null;
      }
      this.debug("Projects::branch()");
      return this.get("projects/" + (parseInt(projectId)) + "/repository/branches/" + (parseInt(branchId)), function(data) {
        if (fn) {
          return fn(data);
        }
      });
    };

    ProjectRepository.prototype.listTags = function(projectId, fn) {
      var _this = this;
      if (fn == null) {
        fn = null;
      }
      this.debug("Projects::listTags()");
      return this.get("projects/" + (parseInt(projectId)) + "/repository/tags", function(data) {
        if (fn) {
          return fn(data);
        }
      });
    };

    ProjectRepository.prototype.listCommits = function(projectId, fn) {
      var _this = this;
      if (fn == null) {
        fn = null;
      }
      this.debug("Projects::listCommits()");
      return this.get("projects/" + (parseInt(projectId)) + "/repository/commits", function(data) {
        if (fn) {
          return fn(data);
        }
      });
    };

    ProjectRepository.prototype.showCommit = function(projectId, commitId, fn) {
      var _this = this;
      if (fn == null) {
        fn = null;
      }
      this.debug("Projects::commit()");
      return this.get("projects/" + (parseInt(projectId)) + "/repository/branches/" + (parseInt(commitId)), function(data) {
        if (fn) {
          return fn(data);
        }
      });
    };

    ProjectRepository.prototype.diffCommit = function(projectId, sha, fn) {
      var _this = this;
      if (fn == null) {
        fn = null;
      }
      this.debug("Projects::diffCommit()");
      return this.get("projects/" + (parseInt(projectId)) + "/repository/branches/" + (parseInt(sha)), function(data) {
        if (fn) {
          return fn(data);
        }
      });
    };

    ProjectRepository.prototype.listTree = function(projectId, fn) {
      var _this = this;
      if (fn == null) {
        fn = null;
      }
      this.debug("Projects::listTree()");
      return this.get("projects/" + (parseInt(projectId)) + "/repository/tree", function(data) {
        if (fn) {
          return fn(data);
        }
      });
    };

    ProjectRepository.prototype.createFile = function(params, fn) {
      var _this = this;
      if (params == null) {
        params = {};
      }
      if (fn == null) {
        fn = null;
      }
      this.debug("Projects::createFile()", params);
      return this.post("projects/" + (parseInt(params.projectId)) + "/repository/files", params, function(data) {
        if (fn) {
          return fn(data);
        }
      });
    };

    ProjectRepository.prototype.updateFile = function(params, fn) {
      var _this = this;
      if (params == null) {
        params = {};
      }
      if (fn == null) {
        fn = null;
      }
      this.debug("Projects::updateFile()", params);
      return this.put("projects/" + (parseInt(params.projectId)) + "/repository/files", params, function(data) {
        if (fn) {
          return fn(data);
        }
      });
    };

    return ProjectRepository;

  })(BaseModel);

  module.exports = function(client) {
    return new ProjectRepository(client);
  };

}).call(this);
